VERSION 5.00
Object = "{1A028BB9-0262-48D8-9B67-D74CE4C2A7E8}#2.0#0"; "IngotTextBoxCtl.dll"
Object = "{9F4EED48-8EC7-4316-A47D-F6161874E478}#2.0#0"; "IngotButtonCtl.dll"
Object = "{899CE9D8-3C9F-48DF-B418-E338294B00E3}#2.0#0"; "IngotCheckBoxCtl.dll"
Begin VB.Form frmCCP 
   BackColor       =   &H00FFFFFF&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Cut, Copy, Paste"
   ClientHeight    =   2400
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   2400
   BeginProperty Font 
      Name            =   "AFPalm"
      Size            =   9
      Charset         =   2
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   160
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   160
   StartUpPosition =   2  'CenterScreen
   Begin IngotCheckBoxCtl.AFCheckBox cbxResize 
      Height          =   180
      Left            =   90
      OleObjectBlob   =   "frmCCP.frx":0000
      TabIndex        =   0
      Top             =   1530
      Width           =   2130
   End
   Begin IngotTextBoxCtl.AFTextBox AFTextBox1 
      Height          =   720
      Left            =   60
      OleObjectBlob   =   "frmCCP.frx":0066
      TabIndex        =   1
      Top             =   225
      Width           =   2280
   End
   Begin IngotButtonCtl.AFButton cmdPaste 
      Height          =   240
      Left            =   1755
      OleObjectBlob   =   "frmCCP.frx":0147
      TabIndex        =   2
      Top             =   1725
      Width           =   525
   End
   Begin IngotButtonCtl.AFButton cmdCopy 
      Height          =   240
      Left            =   1200
      OleObjectBlob   =   "frmCCP.frx":0191
      TabIndex        =   3
      Top             =   1725
      Width           =   525
   End
   Begin IngotButtonCtl.AFButton cmdCut 
      Height          =   240
      Left            =   645
      OleObjectBlob   =   "frmCCP.frx":01DA
      TabIndex        =   4
      Top             =   1725
      Width           =   525
   End
   Begin IngotTextBoxCtl.AFTextBox txtSource1 
      Height          =   240
      Left            =   90
      OleObjectBlob   =   "frmCCP.frx":0222
      TabIndex        =   5
      Top             =   975
      Width           =   2190
   End
   Begin IngotTextBoxCtl.AFTextBox txtSource2 
      Height          =   225
      Left            =   90
      OleObjectBlob   =   "frmCCP.frx":0294
      TabIndex        =   6
      Top             =   1275
      Width           =   2190
   End
End
Attribute VB_Name = "frmCCP"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim mFocusBox As AFTextBox
Dim miSelLen As Integer
Dim miSelStart As Integer
Dim mstrSelText As String
Dim mbResize As Boolean
Dim mbCopyPasteOp As Boolean
Dim mbCutOp As Boolean

Const vchrCommand = &H106
Private Sub cbxResize_Click()
    mbResize = Not mbResize
End Sub
Private Sub cmdCut_Click()
    afExtLib.ClipboardSetString mFocusBox.SelText
    mFocusBox.SelText = ""
End Sub
Private Sub cmdCopy_Click()
    afExtLib.ClipboardSetString mFocusBox.SelText
End Sub
Private Sub cmdPaste_Click()
    If mFocusBox.SelLength = 0 Then
        mFocusBox.Text = Left(mFocusBox.Text, mFocusBox.SelStart) & _
                         afExtLib.ClipboardGetString & _
                         Mid(mFocusBox.Text, mFocusBox.SelStart + 1)
    Else
        mFocusBox.SelText = afExtLib.ClipboardGetString()
    End If
End Sub

Private Sub Form_Activate()
    GraffitiShiftIndicatorInitialize
    GraffitiShiftIndicatorEnable True
    GraffitiShiftIndicatorSetLocation 148, 148
    GraffitiSetShiftState afExtLibShiftNone
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    If mbCutOp Then
        Debug.Print mFocusBox.Text
        Debug.Print Left(mFocusBox.Text, miSelStart)
        Debug.Print Mid(mFocusBox.Text, miSelStart + 2)
        mFocusBox.Text = Left(mFocusBox.Text, miSelStart) & Mid(mFocusBox.Text, miSelStart + 2)
        mbCutOp = False
    End If
    If mbCopyPasteOp Then
        mFocusBox.Text = Left(mFocusBox.Text, Len(mFocusBox.Text) - 1)
        mbCopyPasteOp = False
    End If
End Sub

Private Sub Form_Load()
    RegisterKeyCode vchrCommand
    Set mFocusBox = txtSource1
    mFocusBox.SetFocus
    mbResize = False
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case 262
            miSelLen = mFocusBox.SelLength
            miSelStart = mFocusBox.SelStart
            mstrSelText = mFocusBox.SelText
            GraffitiShiftIndicatorEnable True
        Case 67, 99 'C for Copy
            afExtLib.ClipboardSetString mFocusBox.SelText
            mbCopyPasteOp = True
        Case 86, 118 'V for paste
            If miSelLen = 0 Then
                mFocusBox.Text = Left(mFocusBox.Text, miSelStart) & _
                                 afExtLib.ClipboardGetString & _
                                 Mid(mFocusBox.Text, miSelStart + 1)
            Else
                mFocusBox.SelStart = miSelStart
                mFocusBox.SelLength = miSelLen
                mFocusBox.SelText = afExtLib.ClipboardGetString()
            End If
            mbCopyPasteOp = True
        Case 88, 120 'X for cut
            afExtLib.ClipboardSetString mFocusBox.SelText
            mFocusBox.SelText = ""
            mbCutOp = True
        Case Else
            Debug.Print KeyCode
    End Select
End Sub
Private Sub txtSource1_Change()
    If mbResize Then ResizeBox Else ResetBoxes
End Sub
Private Sub txtSource1_Click()
    Set mFocusBox = txtSource1
End Sub
Private Sub txtSource2_Change()
    If mbResize Then ResizeBox Else ResetBoxes
End Sub
Private Sub txtSource2_Click()
    Set mFocusBox = txtSource2
End Sub
Private Sub ResizeBox()
    mFocusBox.Width = StringWidth("AFPalm", 5, 0, mFocusBox.Text) + 8
    mFocusBox.Height = FontHeight("AFPalm", 5, 0) + 4
End Sub
Private Sub ResetBoxes()
    mFocusBox.Width = 146
    mFocusBox.Height = 16
End Sub

